Development
  • Guides
  • API Reference
  • API Explorer
  • SDKs
  • Sample apps
  • System status
Support
  • Developer forums
  • Developer blog
  • YouTube
  • X
More
  • Square Home
  • Square Developer
  • App Marketplace
  • Partner with Square
  • Solutions Partner Program
  • Pricing
  • Sales

© 2026 Square, Inc.

  • Developer terms of service
  • Developer Integration and Marketing Agreement
  • Privacy policy
  • Partnerships
  • Sign In
  • Sign In

    Labor

  • List break types

  • Create break type

  • Delete break type

  • Get break type

  • Update break type

  • Create scheduled shift

  • Bulk publish scheduled shifts

  • Search scheduled shifts

  • Retrieve scheduled shift

  • Update scheduled shift

  • Publish scheduled shift

  • List team member wages

  • Get team member wage

  • Create timecard

  • Search timecards

  • Delete timecard

  • Retrieve timecard

  • Update timecard

  • List workweek configs

  • Update workweek config

  • Webhooks

  • labor.scheduled_shift.created

  • labor.scheduled_shift.deleted

  • labor.scheduled_shift.published

  • labor.scheduled_shift.updated

  • labor.timecard.created

  • labor.timecard.deleted

  • labor.timecard.updated

<- Labor API

Labor API

All versions ->

Bulk publish scheduled shiftsBeta

POST

 /v2/labor/scheduled-shifts/bulk-publish

Publishes 1 - 100 scheduled shifts.

This endpoint takes a map of individual publish requests and returns a map of responses. When a scheduled shift is published, Square keeps the draft_shift_details field as is and copies it to the published_shift_details field.

The minimum start_at and maximum end_at timestamps of all shifts in a BulkPublishScheduledShifts request must fall within a two-week period.

Permissions:TIMECARDS_WRITE

Guide

Scheduling with the Labor API

Try in API Explorer
Link to section

Request body

Example code

Link to section

scheduled_shifts

Required

A map of 1 to 100 key-value pairs that represent individual publish requests.

  • Each key is the ID of a scheduled shift you want to publish.
  • Each value is a BulkPublishScheduledShiftsData object that contains the version field or is an empty object.
Link to section

scheduled_shift_notification_audience

string

Indicates whether Square should send email notifications to team members and which team members should receive the notifications. This setting applies to all shifts specified in the bulk operation. The default value is AFFECTED.

Link to section

Response fields

Link to section

responses

A map of key-value pairs that represent responses for individual publish requests. The order of responses might differ from the order in which the requests were provided.

  • Each key is the scheduled shift ID that was specified for a publish request.
  • Each value is the corresponding response. If the request succeeds, the value is the published scheduled shift. If the request fails, the value is an errors array containing any errors that occurred while processing the request.
Link to section

errors

Any top-level errors that prevented the bulk operation from succeeding.

Link to section

Examples

All versions ->

POST /v2/labor/scheduled-shifts/bulk-publish
curl https://connect.squareup.com/v2/labor/scheduled-shifts/bulk-publish \ -X POST \ -H 'Square-Version: 2026-11-18' \ -H 'Authorization: Bearer ACCESS_TOKEN' \ -H 'Content-Type: application/json' \ -d '{ "scheduled_shift_notification_audience": "AFFECTED", "scheduled-shifts": { "K0YH4CV5462JB": { "version": 3 }, "scheduled-shift-2": { "version": 2 } } }'

Response JSON

{ "responses": { "idp_key_1": { "scheduled_shift": { "id": "K0YH4CV5462JB", "draft_shift_details": { "team_member_id": "ormj0jJJZ5OZIzxrZYJI", "location_id": "PAA1RJZZKXBFG", "job_id": "FzbJAtt9qEWncK1BWgVCxQ6M", "start_at": "2019-03-25T03:11:00-05:00", "end_at": "2019-03-25T13:18:00-05:00", "notes": "Don't forget to prep the vegetables", "is_deleted": false, "timezone": "America/New_York" }, "published_shift_details": { "team_member_id": "ormj0jJJZ5OZIzxrZYJI", "location_id": "PAA1RJZZKXBFG", "job_id": "FzbJAtt9qEWncK1BWgVCxQ6M", "start_at": "2019-03-25T03:11:00-05:00", "end_at": "2019-03-25T13:18:00-05:00", "notes": "Don't forget to prep the vegetables", "is_deleted": false, "timezone": "America/New_York" }, "version": 3, "created_at": "2019-02-25T03:11:00-05:00", "updated_at": "2019-02-25T03:11:15-05:00" } }, "idp_key_2": { "errors": [ { "category": "INVALID_REQUEST_ERROR", "code": "INVALID_VALUE", "detail": "Scheduled shift with id 'scheduled-shift-2' not found", "field": "scheduled-shifts.scheduled-shift-2" } ] } } }